
#include "globals.h"
#include "smoothing.h"


//filtrerer et gitt hydekart ved filterVerdi fFilter
void filterHeightField(BYTE* fpHeightData, float fFilter)
{
	int i;

	//filtrer fra venstre mot hyre
	for(i=0; i<MAP_SIZE; i++)
		filterHeightBand(&fpHeightData[MAP_SIZE*i], 1, MAP_SIZE, fFilter);
	
	//filtrer fra hyre mot venstre
	for(i=0; i<MAP_SIZE; i++)
		filterHeightBand(&fpHeightData[MAP_SIZE*i+MAP_SIZE-1], -1, MAP_SIZE, fFilter);

	//filtrer fra topp til bunn
	for(i=0; i<MAP_SIZE; i++)
		filterHeightBand(&fpHeightData[i], MAP_SIZE, MAP_SIZE, fFilter);

	//filtrer fra bunn til topp
	for(i=0; i<MAP_SIZE; i++)
		filterHeightBand(&fpHeightData[MAP_SIZE*(MAP_SIZE-1)+i], -MAP_SIZE, MAP_SIZE, fFilter);
}

//brukes av filterHeightField (filtrerer en kolonne med hydeverdier)
void filterHeightBand( BYTE* fpBand, int iStride, int iCount, float fFilter )
{
	float v = fpBand[0];
	int j = iStride;
	int i;

	//g igjennom hydebndet..
	for( i=0; i<iCount-1; i++ )
	{
		fpBand[j] = (BYTE)(fFilter*v + ( 1-fFilter )*fpBand[j]);
		
		v = fpBand[j];
		j += iStride;
	}
}


