
#include "globals.h"
#include <stdlib.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <gl/glut.h>

extern HDC hDC;
unsigned int base;

unsigned int createBitmapFont(char *fontName, int fontSize)							// Build Our Bitmap Font
{
	HFONT	hFont;										// Windows Font ID
    base = glGenLists(96);
	
	hFont = CreateFont(	fontSize,						// Height Of Font
						0,								// Width Of Font
						0,								// Angle Of Escapement
						0,								// Orientation Angle
						FW_BOLD,						// Font Weight
						FALSE,							// Italic
						FALSE,							// Underline
						FALSE,							// Strikeout
						ANSI_CHARSET,					// Character Set Identifier
						OUT_TT_PRECIS,					// Output Precision
						CLIP_DEFAULT_PRECIS,			// Clipping Precision
						ANTIALIASED_QUALITY,			// Output Quality
						FF_DONTCARE|DEFAULT_PITCH,		// Family And Pitch
						fontName);						// Font Name

	if (!hFont)
		return 0;

	SelectObject(hDC, hFont);							// Selects The Font We Want
	wglUseFontBitmaps(hDC, 32, 96, base);				// Builds 96 Characters Starting At Character 32

	return base;
}

GLvoid killFont(GLvoid)									// Delete The Font
{
	if (base != 0)
		glDeleteLists(base, 96);						// Delete All 96 Characters
}

GLvoid printString(unsigned int base, char *str)		// Custom GL "Print" Routine
{
	if ((base == 0) || (str == NULL))
		return;

	glPushAttrib(GL_LIST_BIT);							// Pushes The Display List Bits
		glListBase(base - 32);							// Sets The Base Character to 32
		glCallLists(strlen(str), GL_UNSIGNED_BYTE, str);// Draws The Display List Text
	glPopAttrib();										// Pops The Display List Bits
}

